#!/bin/bash

if [ "$REQUEST_METHOD" = "POST" ]; then
	read QUERY_STRING
	REQUEST_METHOD=GET
	export REQUEST_METHOD
	export QUERY_STRING
fi

function download () {
	PATHCURRENT=$1
	FILECURRENT=$2

	if [ ! -f $PATHCURRENT/$FILECURRENT ]; then
		echo "File non trovato!!"
		exit
	fi
	if [ -z $(echo $FILECURRENT | grep -i gz ) ]; then
		GZIP_ENABLED="N"
	else
		GZIP_ENABLED="Y"
	fi
	if [ "$GZIP_ENABLED" = "Y" ]; then
		echo "Content-Type: application/x-gzip"
	else
		if [ -z $(echo $FILECURRENT | grep -i bmp ) ]; then
			echo "Content-Type: text/plain"
		else
			echo "Content-Type: image/x-ms-bmp"
		fi
	fi
	echo -e "Content-Disposition: attachment; filename=$FILECURRENT\n"
	cat $PATHCURRENT/$FILECURRENT
}

LOGDIR="/usr/local/root/flash/http/log"
DIR=$(ls -1rF $LOGDIR/ | grep /)

if [ "$QUERY_STRING" != "" ]; then
	tmp=${QUERY_STRING%"$"*}
	cmd=${tmp%"="*}
	#echo "cmd = '$cmd'"	
	if [ "$cmd" = "dir" ]; then
		currdir=${tmp#*"="}
		if [ ! -d $LOGDIR/$currdir ]; then
			echo "File non trovato!!"
			exit
		fi
	fi

	tmp=${QUERY_STRING#*"$"}
	cmd=${tmp%"="*}
	case $cmd in
		file)
			currfile=${tmp#*"="}
			download "$LOGDIR/$currdir" $currfile
			;;
		filer)
			currfile=${tmp#*"="}
			download "$LOGDIR/$currdir" $currfile
			rm -rf "$LOGDIR/$currdir/$currfile"
			;;
		clear)
			#it works, but the script hasn't the rights to delete files
			currfile=${tmp#*"="}
			if [ "$currfile" = "Yes" ]; then
				echo "Deleting $LOGDIR/$currdir/"
				rm -rf "$LOGDIR/$currdir/"
				mkdir "$LOGDIR/$currdir"
				chown httpadmin:httpadmin "$LOGDIR/$currdir"
				chmod 755 "$LOGDIR/$currdir"
			fi
			;;
		*)
			echo "Unknown Action: $cmd"
			;;
	esac
	exit
fi

#OUTPUT="> /usr/local/root/flash/http/log.html"
#echo "" >$OUTPUT
OUTPUT=""

function whichmonth () {
	case $1 in
		01/)
			MONTHTXT="January"
			;;
		02/)
			MONTHTXT="February"
			;;
		03/)
			MONTHTXT="March"
			;;
		04/)
			MONTHTXT="April"
			;;
		05/)
			MONTHTXT="May"
			;;
		06/)
			MONTHTXT="June"
			;;
		07/)
			MONTHTXT="July"
			;;
		08/)
			MONTHTXT="August"
			;;
		09/)
			MONTHTXT="September"
			;;
		10/)
			MONTHTXT="October"
			;;
		11/)
			MONTHTXT="November"
			;;
		12/)
			MONTHTXT="December"
			;;
	esac
}


cat $OUTPUT << _EOT_

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <meta content="text/html; charset=ISO-8859-15" http-equiv="content-type">
    <link rel="stylesheet" href="../http/style/style.css" type="text/css">
    <title>Download Log from pCOWeb</title>
  </head>
  <body>
    <table class=maintable>
_EOT_

for i in $DIR; do
	YEAR=${i%_*}
	MONTH=${i##*_}
	whichmonth $MONTH
	echo "      <tr><td class=month colspan=\"3\"><span class=monthtext>$MONTHTXT $YEAR</span></td></tr>" $OUTPUT
	cd $LOGDIR/$i
	FILES=$(ls -1r *csv* 2>/dev/null)
	for a in $FILES; do
		NOMEFILE=${a%%.*}
		echo -n "      <tr><td class=day>\_ <span class=daytext>$NOMEFILE $MONTHTXT $YEAR</span></td><td class=csv><a href=\"$0?dir=$i\$file=$a\">Data</a></td>"
#		BITMAPS=$(ls -1 ${NOMEFILE}*.bmp 2>/dev/null)
#		if [ "$BITMAPS" != "" ]; then
# 			for u in $BITMAPS; do
# 			#	echo "      <tr><td style=\"padding-left: 40px\">\_ BMP</td><td><a href=\"$0?dir=$i\$file=${u}\">Download</a></td></tr>"
# 				echo "<td><a href=\"$0?dir=$i\$file=${u}\">Graph</a></td>"
# 			done
		if [ -f "${NOMEFILE}-graph_1.bmp" ]; then
			echo -n "<td class=bitmap><a href=\"$0?dir=$i\$file=${NOMEFILE}-graph_1.bmp\">Graph</a></td>"
		else
			echo -n "<td class=bitmap></td>"
		fi
		#echo "<td><form method=\"GET\" action=\"$0?dir=$i\$clear=Yes\"><input type=submit value=\"Delete\"></td>"
		echo "</tr>"
	done
	cd -
done

cat $OUTPUT << _EOT_
    </table>
  </body>
</html>
_EOT_
